#include <bits/stdc++.h>
using namespace std;

int main () {
ios_base::sync_with_stdio(false);cin.tie(0);

long long brPuta, pitanje;
cin>>brPuta>>pitanje;

vector<long long>dan(brPuta);
vector<long long>rbrPakovanja(brPuta);

for (int i=1; i<=brPuta; ++i) {
	cin>>dan[i]>>rbrPakovanja[i];
}

sort (dan.begin(), dan.end());

vector<long long>kraj(pitanje);

long long broj_dana=0;
long long trajanjePakovanja=0;
long long brPakovanja=accumulate(rbrPakovanja.begin(), rbrPakovanja.end(), 0);

for (int j=1; j<=pitanje; ++j) {
	cin>>kraj[j];
}

sort (kraj.begin(), kraj.end());

for (int i=1; i<=brPuta; ++i) {
	for (int j=1; j<=pitanje; ++j) {
	if (kraj[j]-dan[i]<0) {
		trajanjePakovanja=0;
		cout<<trajanjePakovanja<<endl;
	}
	
	else {trajanjePakovanja=kraj[j]-dan[i]+1;
	cout<<trajanjePakovanja<<endl;
	}
	
	if (brPakovanja<rbrPakovanja[i]) {
            trajanjePakovanja=brPakovanja;
	}
}
	break;
}
}